2024-02-22 15:10:54

by Laura Nao

[permalink] [raw]
Subject: [PATCH v2] kselftest: Add basic test for probing the rust sample modules

Add new basic kselftest that checks if the available rust sample modules
can be added and removed correctly.

Signed-off-by: Laura Nao <[email protected]>
Reviewed-by: Sergio Gonzalez Collado <[email protected]>
Reviewed-by: Muhammad Usama Anjum <[email protected]>
---
Changes in v2:
- Added missing SPDX line
- Edited test_probe_samples.sh script to use the common KTAP helpers file
---
MAINTAINERS | 1 +
tools/testing/selftests/Makefile | 1 +
tools/testing/selftests/rust/Makefile | 4 ++
.../selftests/rust/test_probe_samples.sh | 42 +++++++++++++++++++
4 files changed, 48 insertions(+)
create mode 100644 tools/testing/selftests/rust/Makefile
create mode 100755 tools/testing/selftests/rust/test_probe_samples.sh

diff --git a/MAINTAINERS b/MAINTAINERS
index c1a18af3593a..5f62904c80bd 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -19207,6 +19207,7 @@ F: Documentation/rust/
F: rust/
F: samples/rust/
F: scripts/*rust*
+F: tools/testing/selftests/rust/
K: \b(?i:rust)\b

RXRPC SOCKETS (AF_RXRPC)
diff --git a/tools/testing/selftests/Makefile b/tools/testing/selftests/Makefile
index f7255969b695..e1504833654d 100644
--- a/tools/testing/selftests/Makefile
+++ b/tools/testing/selftests/Makefile
@@ -80,6 +80,7 @@ TARGETS += riscv
TARGETS += rlimits
TARGETS += rseq
TARGETS += rtc
+TARGETS += rust
TARGETS += seccomp
TARGETS += sgx
TARGETS += sigaltstack
diff --git a/tools/testing/selftests/rust/Makefile b/tools/testing/selftests/rust/Makefile
new file mode 100644
index 000000000000..fce1584d3bc0
--- /dev/null
+++ b/tools/testing/selftests/rust/Makefile
@@ -0,0 +1,4 @@
+# SPDX-License-Identifier: GPL-2.0
+TEST_PROGS += test_probe_samples.sh
+
+include ../lib.mk
diff --git a/tools/testing/selftests/rust/test_probe_samples.sh b/tools/testing/selftests/rust/test_probe_samples.sh
new file mode 100755
index 000000000000..6fcc2cd83d89
--- /dev/null
+++ b/tools/testing/selftests/rust/test_probe_samples.sh
@@ -0,0 +1,42 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# Copyright (c) 2023 Collabora Ltd
+#
+# This script tests whether the rust sample modules can
+# be added and removed correctly.
+#
+
+DIR="$(dirname "$(readlink -f "$0")")"
+
+source "${DIR}"/../kselftest/ktap_helpers.sh
+
+rust_sample_modules=("rust_minimal" "rust_print")
+
+KSFT_PASS=0
+KSFT_FAIL=1
+KSFT_SKIP=4
+
+ret="${KSFT_PASS}"
+
+ktap_print_header
+
+ktap_set_plan "${#rust_sample_modules[@]}"
+
+for sample in "${rust_sample_modules[@]}"; do
+ if ! /sbin/modprobe -n -q "$sample"; then
+ ktap_test_skip "module $sample is not found in /lib/modules/$(uname -r)"
+ continue
+ fi
+
+ if /sbin/modprobe -q "$sample"; then
+ /sbin/modprobe -q -r "$sample"
+ ktap_test_pass "$sample"
+ else
+ ret="${KSFT_FAIL}"
+ ktap_test_fail "$sample"
+ fi
+done
+
+ktap_print_totals
+exit "${ret}"
--
2.30.2



2024-02-22 15:54:40

by Valentin Obst

[permalink] [raw]
Subject: Re: [PATCH v2] kselftest: Add basic test for probing the rust sample modules

> diff --git a/tools/testing/selftests/rust/test_probe_samples.sh b/tools/testing/selftests/rust/test_probe_samples.sh
> new file mode 100755
> index 000000000000..6fcc2cd83d89
> --- /dev/null
> +++ b/tools/testing/selftests/rust/test_probe_samples.sh
> @@ -0,0 +1,42 @@
> +#!/bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# Copyright (c) 2023 Collabora Ltd
> +#
> +# This script tests whether the rust sample modules can
> +# be added and removed correctly.
> +#
> +
> +DIR="$(dirname "$(readlink -f "$0")")"
> +
> +source "${DIR}"/../kselftest/ktap_helpers.sh
> +
> +rust_sample_modules=("rust_minimal" "rust_print")
> +
> +KSFT_PASS=0
> +KSFT_FAIL=1
> +KSFT_SKIP=4

Aren't those constants now defined in `ktap_helpers.sh` as well, i.e.,
could those be removed here?

- Best Valentin

> +
> +ret="${KSFT_PASS}"
> +
> +ktap_print_header
> +
> +ktap_set_plan "${#rust_sample_modules[@]}"
> +
> +for sample in "${rust_sample_modules[@]}"; do
> + if ! /sbin/modprobe -n -q "$sample"; then
> + ktap_test_skip "module $sample is not found in /lib/modules/$(uname -r)"
> + continue
> + fi
> +
> + if /sbin/modprobe -q "$sample"; then
> + /sbin/modprobe -q -r "$sample"
> + ktap_test_pass "$sample"
> + else
> + ret="${KSFT_FAIL}"
> + ktap_test_fail "$sample"
> + fi
> +done
> +
> +ktap_print_totals
> +exit "${ret}"

2024-02-22 16:37:08

by Laura Nao

[permalink] [raw]
Subject: Re: [PATCH v2] kselftest: Add basic test for probing the rust sample modules

On 2/22/24 16:53, Valentin Obst wrote:
>
> Aren't those constants now defined in `ktap_helpers.sh` as well, i.e.,
> could those be removed here?
>
> - Best Valentin
>

Definitely, I forgot to remove them. Thanks for the heads up!

I also noticed there's a ktap_finished function now available that
prints the results summary and handles the return code, so the test
script can be simplified further.

v3 includes these changes: https://lore.kernel.org/linux-kselftest/[email protected]/T/#u

Best

Laura